﻿[xml]$xaml = @"
<Window
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    x:Name="Window"
        Title="Office 365 Management" Height="471.525" Width="663.619">
    <Grid>
        <Label Content="Script ecrit par et pour AC-Tech - acsoyez.fr" HorizontalAlignment="Left" Margin="10,10,0,0" VerticalAlignment="Top" Width="636" FontStyle="Italic" Foreground="Red"/>
        <Rectangle Fill="#FFC7C7FD" HorizontalAlignment="Left" Height="60" Margin="10,55,0,0" Stroke="#FF000CFF" VerticalAlignment="Top" Width="636"/>
        <Label Content="Se connecter à O365" HorizontalAlignment="Left" Margin="10,55,0,0" VerticalAlignment="Top" FontStyle="Italic"/>
        <TextBox x:Name="Login" Text="Login" HorizontalAlignment="Left" Height="23" Margin="17,79,0,0" TextWrapping="Wrap" VerticalAlignment="Top" Width="139"/>
        <PasswordBox x:Name="PwD" HorizontalAlignment="Left" Margin="161,79,0,0" VerticalAlignment="Top" Width="99" Height="23"/>
        <Button x:Name="BtConnect" Content="Connexion" HorizontalAlignment="Left" Margin="265,79,0,0" VerticalAlignment="Top" Width="70" Height="23" Background="White" BorderBrush="#FF002EFF" Foreground="#FF0023FF"/>
        <ListBox x:Name="ListeCred" HorizontalAlignment="Left" Height="46" Margin="340,62,0,0" VerticalAlignment="Top" Width="300" Background="{x:Null}"/>
        <Rectangle Fill="#FFCEFDC7" HorizontalAlignment="Left" Height="115" Margin="10,123,0,0" Stroke="#FF085500" VerticalAlignment="Top" Width="636"/>
        <ListBox x:Name="ListeUser" HorizontalAlignment="Left" Height="87" Margin="17,144,0,0" VerticalAlignment="Top" Width="300"/>
        <Label Content="Liste des Utilisateurs" HorizontalAlignment="Left" Margin="10,123,0,0" VerticalAlignment="Top" FontStyle="Italic" FontSize="10"/>
        <Button x:Name="BtCheckUser" Content="CheckUser" HorizontalAlignment="Left" Margin="322,144,0,0" VerticalAlignment="Top" Width="75" BorderBrush="#FF085500" Background="White" Foreground="#FF085500"/>
        <ListBox x:Name="UserDetail" HorizontalAlignment="Left" Height="87" Margin="402,144,0,0" VerticalAlignment="Top" Width="238"/>
        <Label x:Name="Lbl_CheckUser" Content="" HorizontalAlignment="Left" Margin="322,188,0,0" VerticalAlignment="Top" Width="75"/>
        <Button x:Name="BtDeleteUser"  Content="Delete User" HorizontalAlignment="Left" Margin="577,126,0,0" VerticalAlignment="Top" Width="63" Background="{x:Null}" BorderBrush="Red" Foreground="Red" FontStyle="Italic" FontWeight="Bold" FontSize="10"/>
        <Button x:Name="Bt_Refresh" Content="Bt_Refresh" HorizontalAlignment="Left" Margin="242,126,0,0" VerticalAlignment="Top" Width="75" FontStyle="Italic" FontSize="10" Background="White" BorderBrush="#FF085500" Foreground="#FF085500"/>
        <Rectangle Fill="#FFB2E2FD" HorizontalAlignment="Left" Height="115" Margin="10,243,0,0" Stroke="#FF04A5FF" VerticalAlignment="Top" Width="636"/>
        <Label Content="Utilisateurs à la corbeille" HorizontalAlignment="Left" Margin="10,243,0,0" VerticalAlignment="Top" FontStyle="Italic" FontSize="10"/>
        <ListBox x:Name="ListeUserDeleted" HorizontalAlignment="Left" Height="87" Margin="17,266,0,0" VerticalAlignment="Top" Width="300"/>
        <ListBox x:Name="DelUserDetail" HorizontalAlignment="Left" Height="87" Margin="360,266,0,0" VerticalAlignment="Top" Width="212"/>
        <Button x:Name="Bt_CheckDelUser" Content=">>" HorizontalAlignment="Left" Margin="322,273,0,0" VerticalAlignment="Top" Width="33" BorderBrush="#FF085500" Background="White" Foreground="#FF085500"/>
        <Button x:Name="Bt_DelUser_Resume"  Content="Resume User" HorizontalAlignment="Left" Margin="577,287,0,0" VerticalAlignment="Top" Width="63" Background="{x:Null}" BorderBrush="Red" Foreground="Red" FontStyle="Italic" FontWeight="Bold" FontSize="10" Height="40"/>
    </Grid>
</Window>
"@
$reader = (New-Object System.Xml.XmlNodeReader $xaml)
$window = [Windows.Markup.XamlReader]::Load($reader)

#Définition des variables en fonction des noms des éléments (bouton, text box, label ...)
$Login = $window.FindName("Login")
$PwD = $window.FindName("PwD")
$BtConnect = $window.FindName("BtConnect")
$ListeCred = $window.FindName("ListeCred")
$ListeUser = $window.FindName("ListeUser")
$BtCheckUser = $window.FindName("BtCheckUser")
$Lbl_CheckUser = $window.FindName("Lbl_CheckUser")
$UserDetail = $window.FindName("UserDetail")
$BtDeleteUser = $window.FindName("BtDeleteUser")
$Bt_Refresh = $window.FindName("Bt_Refresh")
$ListeUserDeleted = $window.FindName("ListeUserDeleted")
$DelUserDetail = $window.FindName("DelUserDetail")
$Bt_CheckDelUser = $window.FindName("Bt_CheckDelUser")
$Bt_DelUser_Resume = $window.FindName("Bt_DelUser_Resume")

#Fonction de recharges des listes et effacement des sélections
function RefreshListes 
{ 
    #Effacement des listes affichées
    $ListeUser.Items.Clear()
    $ListeUserDeleted.Items.Clear()
    $UserDetail.Items.Clear()
    $DelUserDetail.Items.Clear()

    #Chargement de la liste des users
    $ListUsers = Get-MsolUser | Sort-Object -property DisplayName
        Foreach ($user in $ListUsers)
    {
        $ListeUser.Items.Add($user.UserPrincipalName)
    }
    $ListeUserDeleted.Items.Clear()
    $DelUsers = Get-MsolUser -All -ReturnDeletedUsers
    #Affiche dans la liste les utlisateurs qui se trouvent dans la corbeille
    Foreach ($DelUser in $DelUsers)
    {
        $ListeUserDeleted.Items.Add($DelUser.UserPrincipalName)
    }
}
#Connection au Tenant Office 365
$BtConnect.add_Click({
    Import-module msonline
    $username = $Login.Text
    #Récupération du camp Password et conversion en SecurePassword
    $SecurePWD = ConvertTo-SecureString -String $PWD.Password.ToString() -AsPlainText -Force
    #Création des crédentials pour la connexion au Tenant O365
    $cred = new-object -typename System.Management.Automation.PSCredential -argumentlist $username, $SecurePWD
    #Connexion au Tenant O365
    Connect-MsolService -Credential $Cred
    #Récupération du Role de l'utilisateur
    $CredRole = Get-MsolUserRole -UserPrincipalName $username
    #Récupération du Nom complet de l'utilisateur Authentifié
    $CredUser = Get-MsolUser -UserPrincipalName $username
    #Affichage du Nom et du Role dans la ListeBox
    $ListeCred.Items.Add("Bonjour "+$CredUser.DisplayName+" !")
    $ListeCred.Items.Add("Vous êtes "+$CredRole.Name)
    RefreshListes
})

#Détail d'un utilisateur sélectionner dans la liste
$BtCheckUser.add_Click({
    #Efface la liste des détails
    $UserDetail.Items.Clear()
    #Récupération des informations liées à l'utilisateur sélectionné
    $SelectedUser = Get-MsolUser -UserPrincipalName $ListeUser.SelectedItem
    
    $UserDetail.Items.Add("UserPrincipalName : "+$SelectedUser.UserPrincipalName)
    $UserDetail.Items.Add("Prénom : "+$SelectedUser.Firstname)
    $UserDetail.Items.Add("Nom : "+$SelectedUser.Lastname)
    $UserDetail.Items.Add("Licenced : "+$SelectedUser.isLicensed)

})


#Supression de l'utilisateur séléectionné
$BtDeleteUser.add_Click({ 
    Remove-MsolUser -UserPrincipalName $ListeUser.SelectedItem
    RefreshListes
})

#Refresh de la liste des utilisateurs actifs
$Bt_Refresh.add_Click({ 
    RefreshListes
})

#Détail d'un utilisateur sélectionner dans la liste
$Bt_CheckDelUser.add_Click({
    #Efface la liste des détails
    $DelUserDetail.Items.Clear()
    #Récupération des informations liées à l'utilisateur sélectionné
    $SelectedDelUser = Get-MsolUser -UserPrincipalName $ListeUserDeleted.SelectedItem -ReturnDeletedUsers
    #Affichage des informations dans la ListeBox
    $DelUserDetail.Items.Add("UserPrincipalName : "+$SelectedDelUser.UserPrincipalName)
    $DelUserDetail.Items.Add("Prénom : "+$SelectedDelUser.Firstname)
    $DelUserDetail.Items.Add("Nom : "+$SelectedDelUser.Lastname)
    $DelUserDetail.Items.Add("Licenced : "+$SelectedDelUser.isLicensed)
})


#Restauration de l'utilisateur sélectionné
$Bt_DelUser_Resume.add_Click({
    #Restauration de l'utilisateur séléectionné
    Restore-MsolUser -UserPrincipalName $ListeUserDeleted.SelectedItem
    RefreshListes
})

$window.ShowDialog()
